;
;	>> Atari Calculator Loader for ROM Image <<
;
;	(c) 2013-10-31 - 2013-11-05 by Peter Dell / JAC!
;
;	Select "Turn off ANTIC while loading this program" in the AtariMax Studio.

; OS
warmst		= $08
dosvec		= $0a
dosini		= $0c
ciov		= $e456

; Zero page
p1		= $80
p2		= $82
cnt		= $84

; Code
dos_target	= $700
dos_init 	= $1540

calculator_target = $3b00
picture_target	  = $a100

pal	= $d014

	org $5d00		;Page after $5c05

	mwa #dos_source p1
	mwa #dos_target p2
	ldx #>[.len dos_source+$ff]
	jsr copy_memory
	mwa #dos_init dosini
	mva #$ff warmst
	jsr dos_init
	mwa #calculator_source p1
	mwa #calculator_target p2
	ldx #>[.len calculator_source+$ff]
	jsr copy_memory

	lda #$ff		;Deactivate BASIC on XL/XE machines
	sta $d301

	.proc copy_picture
	mwa #picture_source p1
	mwa #picture_target p2
	ldx #144
loop1	ldy #39
	lda #0
loop2	sta (p2),y
	dey
	bpl loop2
	adw p2 #11
	ldy #17
loop3	lda (p1),y
	sta (p2),y
	dey
	bpl loop3
	adw p1 #18 
	adw p2 #40-11
	dex
	bne loop1
	.endp

wait_key_released
	lda $d20f
	and #12
	cmp #12
	bne wait_key_released

	jsr open_editor
	
	mwa #8*50 cnt
	lda pal
	and #$0e
	beq is_pal

	mwa #8*60 cnt
	mwa #dl.ntsc dl.vblank
is_pal
	mwa dl.vblank $230

	mva #$0f 709
	mva #$00 710
	lda #8
	sta $d208
	lda #3
	sta $d20f

loop	lda $d40b
	bne loop
	ldx #0
kernel	txa
	asl
	sta $d40a
	sta $d016
	inx
	bpl kernel

	lda $d20f
	and #12
	cmp #12
	bne skip
	dew cnt
	lda cnt
	ora cnt+1
	bne loop

skip	lda $d209
	sta 764
	lda #0
	sta $d201
	sta $d203

	jsr open_editor
	ldx #$ff
	lda 764
	stx 764
	cmp #$1c
	beq start_dos
	jsr $3b00
	jmp $5c05
start_dos
	jmp (dosvec)

 
	.local dl
pal	.byte $70
ntsc	.byte $50,$30,$47,a(sm),$70,$06,$70,$07,$70,$06,$30
	.byte $4f,a(picture_target)
:95	.byte $0f
	.byte $4f,a(picture_target+$f00)
:47	.byte $0f
	.byte $41
vblank	.word dl.pal
	.endl
	
	.local sm
	.byte "  ATARI CALCULATOR  "
	.byte "   PROGRAMMED BY    "
	.byte "     CAROL SHAW     "
	.byte "  ROM VERSION 2013  "
	.endl

	.byte "BY PETER DELL / JAC!"	;Hidden

	.proc open_editor
	ldx #$00
	mva #$0c $342,x
	jsr ciov
	mva #$03 $342,x
	mwa #editor $344,x
	mva #12 $34a,x
	mva #0 $34b,x
	jsr ciov
	rts

	.local editor
	.byte 'E:',$9b
	.endl

	.endp

	.proc copy_memory
	ldy #0
loop	lda (p1),y
	sta (p2),y
	iny
	bne loop
	inc p1+1
	inc p2+1
	dex
	bne loop
	rts
	.endp

	.local dos_source
	ins "DOS-Dump-$0700-$19dc.bin"
	.endl
	
	.local calculator_source
	ins "Atari Calculator Original.xex",+6,$2106
	.endl
	
	.local picture_source
	ins "Carol-Shaw.pic"
	.endl

